use url::Url;
use crate::server::response::{Status, Header, Response};

pub trait Handler {
    fn handle(&self, url : Url) -> Option<Response>;
}

pub struct TestHandler {
}

impl Handler for TestHandler {
    fn handle(&self, url : Url) -> Option<Response> {
        let header = Header::new(Status::Success, "text/gemini");
        return Some(Response::new(header, Vec::new()));
    }
}
